module(..., package.seeall)

local replaceNil

calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or '' 
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

replaceNil = function (a, ...)
                   if(#{...} == 0) then 
                      return a
                   else
                      return (a or ""), replaceNil(...)
                   end
                end

local fstr = function (...)
             return table.concat({replaceNil(...)})
          end

local calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or '' 
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
               end
local urlDecode = function(s)
                     return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                          "%%(%x%x)",
                                          function (str)
                                             return string.char (tonumber (str, 16))
                                          end )
                          )
                  end

local function htmlEncode (s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end
local function  gen_channel_stat(mod_uita, tunnel, channel) 
      local subc;
      uita_con  = mod_uita.con(tunnel)
      if((type(uita_con) ~= 'nil') and (type(uita_con[tunnel]) ~= 'nil')and (type(uita_con[tunnel][tonumber(channel)]) ~= 'nil')) then
         subc=uita_con[tunnel];
      else 
         return "No such object.";
      end
    
      return fstr("<center><h>",tunnel,":",channel,"</h>",
                  "<table border=1 align=center  class=\"chan_table\">",
                  "<tr><td>peerHost</td><td>", subc[tonumber(channel)]['peerHost'],"</td></tr>",
                  "<tr><td>peerPort</td><td>", subc[tonumber(channel)]['peerPort'],"</td></tr>",
                  "<tr><td>direction</td><td>", subc[tonumber(channel)]['direction'],"</td></tr>",
                  "<tr><td>host</td><td>", subc[tonumber(channel)]['host'],"</td></tr>",
                  "<tr><td>port</td><td>", subc[tonumber(channel)]['port'],"</td></tr>",
               "</table></center>");
   end

local function gen_tunnel_stat(mod_uita, tun, htmlEnv)
   local   function get_color_from_state( state)
           return (tostring(state) == "dead" and "red" or
                         (tostring(state) == "normal" and "green" or
                                (tostring(state) == "suspended" and "blue" or "grey")))
   end
   local  function make_time(t)
             local ret="";
             t=tonumber(t)
             if(type(t)~='number') then
                return "Error"
             end
             
             ret = os.date("!%H:%M:%S",t)
             if ( t >= 60*60*24 ) then
                ret=os.date("!%d&nbsp;",t)..ret;
             end;
             if ( t >= 30*60*60*24 ) then
                ret=os.date("!%m.",t)..ret;
             end;   
             if ( t >= 365*60*60*24 ) then
                ret=os.date("!%Y.",t)..ret;
             end;
             return ret
          end
   local  function make_diff_time(t)
             local ret="";
             t=tonumber(t)
             if(type(t)~='number') then
                return "Error"
             end
             ret =  (math.floor(t / (60*60*24)) >0 and tostring(math.floor(t / (60*60*24))).."&nbsp;" or "") .. os.date("!%H:%M:%S",t)
             return ret
          end

   local function get_next_interval(i)
      if (i==96)
      then
         return 1
      else
         return i+1
      end
   end

   local function get_prev_interval(i)
      if (i==1)
      then
         return 96
      else
         return i-1
      end
   end

   local stat={};
   local int_stat={};
   local links_stat={"<table border=1 class=\"link_table\"><caption colspan=3>Статистика использования интерфейсов</caption>"};
   local state_stat={"<table border=1 class=\"state_table\"><caption colspan=3>Статистика состояний тоннеля</caption>"};

   local tun_stat = mod_uita.stat(tun)
   local uita_stat = mod_uita.stat()
   if(type(tun)=="string") then
      tun_stat=tun_stat['tun'][tun];
      if(type(tun_stat)=='table') then
       --[[  if( not http_data_equal("interval", 15)
          and not htmlEnv.data["interval"] == 24)
             and not http_data_equal("interval", 8 )
             and not http_data_equal("interval", 88))
   then--]]
            htmlEnv.data["interval"] = 88;
      --[[   end;
         --]]
         ----table  link
         local links=tun_stat['links'];
         links_stat[#links_stat+1] = "<tr><th>link</th><th>duration</th><th>quantity</th></tr>"
         if(type(links)=='table') then
            if (type(links[tun_stat['link']]) ~= 'nil') then
               links[tun_stat['link']]['duration'] = links[tun_stat['link']]['duration'] + uita_stat['time'] -tun_stat['currStateTime'];
               links[tun_stat['link']]['quantity'] = links[tun_stat['link']]['quantity'] + 1;
            else
               if(type(tun_stat['link']) == 'nil') then
                  tun_stat['link']= 'none'
               end;
               links[tun_stat['link']]={};
               links[tun_stat['link']]['duration'] = uita_stat['time'] - tun_stat['currStateTime'];
               links[tun_stat['link']]['quantity'] =  1;
            end;
            
            
            for i,v in pairs(links) do
               if(type(v)=='table') then
                  links_stat[#links_stat+1] = fstr(
                     "<tr><td>",
                     tostring(i),
                     tostring(i) == (tun_stat['link'] or 'none') and  "(current)" or "",
                     "</td><td>",
                     make_diff_time(v['duration'] or '0'),
                     "</td><td>",
                     tostring(v['quantity'] or '0'),
                     "</td></tr>"
                  )
               end
            end
            end
            links_stat[#links_stat+1] = "</table>"
	   
            ------------
            ----table state
            local state=tun_stat['state'];
            state_stat[#state_stat+1] = "<tr><th>state</th><th>duration</th><th>quantity</th><tr>"
            
            if(type(state)=='table') then
               
               
	       if (type(state[tun_stat['currState']]) ~= 'nil') then
            state[tun_stat['currState']]['duration'] = state[tun_stat['currState']]['duration'] + uita_stat['time'] -tun_stat['currStateTime'];
            state[tun_stat['currState']]['quantity'] = state[tun_stat['currState']]['quantity'] + 1;
	       else
            state[tun_stat['currState']]={};
            state[tun_stat['currState']]['duration'] = uita_stat['time'] - tun_stat['currStateTime'];
            state[tun_stat['currState']]['quantity'] =  1;
	       end;
	       
         
	       for i,v in pairs(state) do
            if(type(v)=='table') then
               state_stat[#state_stat+1] = fstr(
                  "<tr><td>",
                  tostring(i),
                  tostring(i) == tun_stat['currState'] and "(current)" or "",
                  "</td><td>",
                  make_diff_time(v['duration']),
                  "</td><td>",
                  tostring(v['quantity']),
                  "</td></tr>"
               )
            end
         end
      end
      state_stat[#state_stat+1] = "</table>"

----------------
-------table state & intervals
      int_stat[#int_stat+1] = [[<table border=1 class="int_table">
               <caption colspan=7>Статистика передачи данных</caption>
         ]]

     int_stat[#int_stat+1] = [[
               <tr><th colspan=2>interval</th>
               <th>recvPack</th>
               <th>recvBytes</th>
               <th>sendPack</th>
               <th>sendBytes</th>
               <th>sendErr</th>
               </tr> ]]

 	    local i_time = math.floor(uita_stat['time']/(15*60)) * (15*60);
 	    --
	    local k = tun_stat['currentTimeInterval'];
	    if(type(tun_stat[k]) == 'table') then
	       int_stat[#int_stat+1] = fstr(
            "<tr><td>Current</td><td>",
            make_time(i_time)," - ",
            make_time(uita_stat['time']),"<br>",
            make_diff_time(uita_stat['time'] - i_time),
            "<td>",tun_stat[k]['recvPack'] or '0',"</td>",
			      "<td>",tun_stat[k]['recvBytes'] or '0',"</td>",
			      "<td>",tun_stat[k]['sendPack'] or '0',"</td>",
			      "<td>",tun_stat[k]['sendBytes'] or '0',"</td>",
			      "<td>",tun_stat[k]['sendErr'] or '0',"</td>",
            "</tr>"
         )
	    end
       k=get_prev_interval(k);
      if(type(tun_stat[k]) == 'table') then
          int_stat[#int_stat+1] = fstr(
             "<tr><td>Previous</td><td>",
			       make_time(i_time  -  15*60)," - ",
             make_time(i_time),"<br>",
             make_diff_time( 15*60),
			       "<td>",tun_stat[k]['recvPack'] or '0',"</td>",
			       "<td>",tun_stat[k]['recvBytes'] or '0',"</td>",
			       "<td>",tun_stat[k]['sendPack'] or '0',"</td>",
			       "<td>",tun_stat[k]['sendBytes'] or '0',"</td>",
			       "<td>",tun_stat[k]['sendErr'] or '0',"</td>",
            "</tr>"
          )
	     end
 	     -----------
	    --if( http_data_equal("interval", 24) or http_data_equal("interval", 88)) then
       int_stat[#int_stat+1] = fstr(
          "<tr><td>Last 24 hours</td><td>",
          make_time(i_time - 3600*24 + 15*60),
          " - ",
          make_time(uita_stat['time']),"<br>",
          make_diff_time(uita_stat['time']-(i_time - 3600*24 + 15*60)),
          "<td>",tun_stat["day"]['recvPack'] or '0',"</td>",
          "<td>",tun_stat["day"]['recvBytes'] or '0',"</td>",
          "<td>",tun_stat["day"]['sendPack'] or '0',"</td>",
          "<td>",tun_stat["day"]['sendBytes'] or '0',"</td>",
          "<td>",tun_stat["day"]['sendErr'] or '0',"</td>",
          "</tr>"
       )
       --end;	 
       --
	     --if( http_data_equal("interval", 8) or http_data_equal("interval", 88)) then
       int_stat[#int_stat+1] = fstr(
          "<tr><td>From Start</td><td>",
          make_time(uita_stat['startTime']),
          " - ",
          make_time(uita_stat['time']),"<br>",
          make_diff_time(uita_stat['time'] - uita_stat['startTime']),
          "<td>",tun_stat['recvPack'] or '0',"</td>",
          "<td>",tun_stat['recvBytes'] or '0',"</td>",
          "<td>",tun_stat['sendPack'] or '0',"</td>",
          "<td>",tun_stat['sendBytes'] or '0',"</td>",
          "<td>",tun_stat['sendErr'] or '0',"</td>",
          "</tr>"
       )
	     --end;
	     -------
       int_stat[#int_stat+1] = "</table>"

	    ----------------------------
	    -----------table stat

       stat[#stat+1] = fstr([[<table border=1 class="stat_table"
                                  <caption colspan=3>Параметры тоннеля</caption>
                                  <tr><td>link</td>]],
                         "<td>",tun_stat['link'] or 'none',"</td></tr>",
                         "<tr><td>peer</td><td>",tun_stat['peer'] or 'none',"</td></tr>",
                         "<tr><td>state</td><td><font ",
                         "color=\"", get_color_from_state(tun_stat['currState']),"\">",
                         tun_stat['currState'],"</font></td></tr>",
                         "<tr><td>currStateTime</td><td>",
                         make_diff_time(uita_stat['time']-tun_stat['currStateTime']),
                         "</td></tr>",
                         "<tr><td>time</td><td>",make_time(uita_stat['time']),"</td></tr>",
                         "<tr><td>csq</td><td>",(tun_stat.peerData and tun_stat.peerData.csq) or 'none',
                         "</td></tr></table>")

	    ----------------------------------

  end;
end;
      return  fstr("<center><h>",
                   tun,
                   (tun_stat.description and " - " or ""),
                   (tun_stat.description or ""),"</h>",
                   table.concat(stat),
                   table.concat(links_stat),
                   table.concat(state_stat),
                   --gen_stat_buttons(),
                   table.concat(int_stat),
                   "</center>"
                );
   end;



_L = {
   start = function (ses, htmlEnv)
              return true, fstr([[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                                <html>
                                <head>
                                <title>NSG uiTCP Client/Server Viewer</title>
                                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                                <script src="/jquery.js" type="text/javascript" ></script> 
                                <script src="/tinysort.js" type="text/javascript" ></script>
                                <xscript src="/boxover.js" type="text/javascript" ></script>
                                <xscript src="/webtty.js" type="text/javascript" ></script>
                                <link rel="stylesheet" type="text/css" href="/style.css">
                                <link rel="icon" type="image/x-icon" href="/nsg.ico">
                                <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico">
                                </head>]],
                       "<script type=\"text/javascript\">var SID=\"",
                       htmlEnv.data.sesnum,
                       "\";var PATH=",
                       ("%q"):format(htmlEnv.data.path),
                       ";var LOGIN=\"",
                       htmlEnv.data.login,
                       "\";var PASS=\"",
                       htmlEnv.data.pass,
                       "\";var AUTH=\"login=\"+LOGIN+ \"&pass=\" + PASS +\"&sesnum=\"+ SID +\"&path=\" + PATH + \"&\";var PAGENAME=\""..htmlEnv.data.pagename.."\";var LOCALE=\"",
                       locale,"\";var CONTENT=\"\";var TIMER=null; var REQUEST=null;</script>",
                       "<script src=\"/script.js\" type=\"text/javascript\" ></script>",
                             [[   <script type="text/javascript">
                                var update;
                                function setContent(eThis) {
                                      CONTENT = "";
                                      do {
                                            eThis = $(eThis).parent().closest("li");
                                            if(eThis.size()==0)
                                               break;
                                            CONTENT=  "\"" + $(eThis).attr('name') + "\"," + CONTENT;
                                         }
                                       while (1);
                                       CONTENT = "{" + CONTENT + "}";
                                       update();
                                   };
                                function genLi(name, class , text) {
                                       var li = document.createElement("LI");
                                       $(li).addClass(class);
                                       $(li).attr('name', name);
                                       $(li).attr('id', name);
                                       li.innerHTML = "<table class=\"node\">"+
                                          "<tbody>"+
                                          "<tr valign=\"top\">"+
                                          "<td>"+
                                          "<a class=\"sc\" onclick=\" UnHide(this); return false;\" title=\"\">"+
                                          "<img src=\"/expand.png\"/>"+
                                          "</a>"+
                                          "<a class=\"sch\" onclick=\" UnHide(this); return false;\" title=\"header=[webBtnCollapse] body=[]\">"+
                                          "<img src=\"/collapse.png\"/>"+
                                          "</a>"+
                                          "</td>"+
                                          "<td class=\"param\" width=\"120\" title=\"\">"+
                                          "<span class=\"dir\">"+
                                          "<a class=\"name\" onclick=\" setContent(this); return false;\" onkeydown=\"paramKeyDown(event, this)\" href=\"javascript:void(0)\">"+text+"</a>"+
                                          "</span>"+
                                          "<input class=\"value\" type=\"hidden\" value=\"sys\" name=\"sys\"/>"+
                                          "</td>"+
                                          "<td class=\"value\"> </td>"+
                                          "<td class=\"itemcontrols\"> </td></tr>"+
                                          "</tbody>"+
                                          "</table>"+
                                          "<div class=\"dir\">"+
                                          "<div class=\"dircontrol\">"+
                                          "</div>"+
                                          "<ul>  </ul>"+
                                          "</div>";
                                       return li;
                                    };


                                function updateMenu(){
                                   };
                                function updateContent(){
                                   };

                                function delTun(tun) {
                                      $("li[name='"+tun+"']").remove();
                                   };
                                function delTunCh(tun, ch) {
                                      $($("li[name='"+ch+"']") ,$("li[name='"+tun+"']")).remove();
                                   };
                                function updTun(tun, state) {
                                      if (0==$("li[name='"+tun+"']").size()) {
                                         $("ul.root")[0].appendChild(genLi(tun, state, tun));
                                         $($("ul.root")[0]).tsort("li",{attr:"name"});
                                      }
                                   };

                                function updTunCh(tun, index, host, port, peerHost, peerPort, direction) {
                                      var text = "["+index+"] " + peerHost +":"+  peerPort + " " + direction + " " + host +":"+ port;
                                      if (0==$("li[name='"+index+"']").size()) {
                                         $("li[name='"+tun+"'] div.dir ul" )[0].appendChild(genLi(index, "channel", text));
                                         $($("li[name='"+tun+"'] div.dir ul" )[0]).tsort("li",{attr:"name"});
                                      }
                                   };

                                update = function (){
                                      if(TIMER) {
                                         clearTimeout(TIMER);
                                         TIMER=null;
                                      } 
                                      if (REQUEST) {
                                         REQUEST.abort();
                                         REQUEST = null;
                                      }
                                      var menu = "{";
                                      $("li:has(li)").each(function (index, Elem) {
                                                         menu = menu + "['" + $(Elem).attr('name') + "'] = {";
                                                         var nameLen = $(Elem).attr('name').length;
                                                         $("li", Elem).each(
                                                            function (index, Elem) {
                                                                  var id = $(Elem).attr('name');
                                                                  menu = menu + "[" + id + "] = {},";
                                                               }
                                                         );
                                                         menu = menu + "},";
                                                      });
                                      menu = menu + "}";
                                      REQUEST = $.post("/",
                                                       "command=getHTML&subcmd=update&menu="+encodeURIComponent(menu)+"&content="+encodeURIComponent(CONTENT)+"&"+AUTH,
                                                       function(data) {
                                                             //alert(data);
                                                             REQUEST = null;
                                                             eval(data);
                                                             if(TIMER) {
                                                                clearTimeout(TIMER);
                                                                TIMER=null;
                                                             }
                                                             TIMER = setTimeout('update()',5000);
                                                          });
                                };
                                function onLoad(){
                                      update();
                                   };
                                </script>
                       ]],
                       "<body onload=\"onLoad();\">",
                       "<center><strong>NSG <i>ui</i>TCP<sup>&reg;</sup>  Client/Server Viewer</strong></center><br/>",
                       "<table width=100% >",
                       "<colgroup><col width=200></col><col></col></colgroup>",
                       "<tr valign=top><td class=\"menu\"> <span class=\"dir\">",
                    "<a class=\"name\" onclick=\"CONTENT='{}';update(); return false;\" onkeydown=\"paramKeyDown(event, this)\" href=\"javascript:void(0)\">SUMMARY</a><br>",
                       "</span><ul id=\"root\" class=\"root\"></td><td class=\"content\"></td></tr>",
                       "</table>",
                       "</body></html>"
                    )
           end,
   update = function (ses, htmlEnv)
               local oldMenu = calcValue(urlDecode(htmlEnv.data.menu or "{}"))
               local out = {}
               local mod_uita = require"uita"
               local con = mod_uita.con()
               local sort = {};
               if not con then
                  return true,'alert("Can`t get stat. May be uiTCP it not started yet?");'
               end
               for k in pairs(con) do
                  sort[#sort + 1] = tostring(k);
               end
               table.sort(sort);
               for k,tun in ipairs(sort) do
                  local tunName = ("%q"):format(tun)
--[[                  local stat = mod_uita.stat(tun)
                  if not stat or not stat.tun or not stat.tun[tun] then
                     return true,'alert("Can`t get con. What`s this?");'
                  end
                  --]]
                  if oldMenu[tun]== nil then
                     oldMenu[tun]={}
                  end
                  if con[tun]["currState"]~= oldMenu[tun]["currState"] then
                     out[#out+1] = fstr('updTun(',tunName,',"',
                                        tostring(con[tun]["currState"]),'");')
                  end
                  for k,ch in pairs(con[tun]) do
                     if type(ch) == "table" then
                        if oldMenu[tun][k] == nil or
                           ch.host    ~=oldMenu[tun][k].host or
                           ch.port    ~=oldMenu[tun][k].port or
                           ch.peerPort~=oldMenu[tun][k].peerPort or
                           ch.peerHost~=oldMenu[tun][k].peerHost or
                           ch.direction~=oldMenu[tun][k].direction
                        then
                           out[#out+1] =  fstr('updTunCh(',tunName,',"',
                                               tostring(k),'","',
                                               tostring(ch.host),'","',
                                               tostring(ch.port),'","',
                                               tostring(ch.peerHost),'","',
                                               tostring(ch.peerPort),'","',
                                               tostring(ch.direction),'");')
                        end
                        oldMenu[tun][k]= false
                     end
                  end
                  for k,ch in pairs(oldMenu[tun]) do
                     if type(ch) == "table" then
                        out[#out+1] =  fstr('delTunCh(',tunName,',"',
                                            tostring(k),'");')
                     end
                  end
                  oldMenu[tun] = nil
               end
               for tun in pairs(oldMenu) do
                  out[#out+1] =  'delTun('..("%q"):format(tun)..');'
               end
               if type(htmlEnv.data.content)=='string'then
                  local content = calcValue(htmlEnv.data.content) or {}
                  if type(content) == 'table' then

                     if #content == 0 then
                        local escapeForScript = function (s)
                                      return string.gsub(string.gsub(string.gsub(string.gsub(tostring(s) or "","\r","\\\r"),"\n","\\\n"),"\"","\\\""),"'","\\'");
                                   end
                        local htmlEncode = function (s)
                           return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                                         "\"",
                                                                         "&quot;"),
                                                            "<",
                                                            "&lt;"),
                                               ">",
                                               "&gt;")
                        end

                        out[#out+1] = fstr("$(\"td.content\")[0].innerHTML = \"<pre>\"+",
                                           string.gsub(("%q"):format(io.popen("top -b -n 1 -d 0"):read("*a")),"\\\n","<br>\"+\""),
                                           "+\"</pre>\";")
                     elseif #content == 1 then
                        out[#out+1] = fstr("$(\"td.content\")[0].innerHTML = " ,
                                           string.gsub( ("%q"):format(gen_tunnel_stat(mod_uita,content[1], htmlEnv)),"\\\n","\"+\n\""),
                                           ";")
                     elseif #content == 2 then
                        out[#out+1] = fstr("$(\"td.content\")[0].innerHTML = " ,
                                           string.gsub( ("%q"):format(gen_channel_stat(mod_uita, content[1],content[2])),"\\\n","\"+\n\""),
                        ";")
                     end
                  else
                     out[#out+1] =  "$(\"td.content\")[0].innerHTML = "..("%q"):format(htmlEnv.data.content)..";"
                  end
                 -- out[#out+1] =  "$(\"strong\")[0].innerHTML = "..("%q"):format(htmlEnv.data.content..":"..tostring(content).."#".. tostring(#content))..";"
               end
               return true, table.concat(out,"\n")
            end
}


-- Entry point for call from web
function getHTML(ses, htmlEnv)
   if _L[htmlEnv.data.subcmd]  then
      return (_L[htmlEnv.data.subcmd])(ses, htmlEnv)
   else
      return nil, "Can`t find function `"..htmlEnv.data.subcmd.."` in module `uitcpweb`."
   end

end