module(..., package.seeall)
replaceNil = function (a, ...)
                   if(#{...} == 0) then 
                      return a
                   else
                      return (a or ""), replaceNil(...)
                   end
                end

local fstr = function (...)
             return table.concat({replaceNil(...)})
          end

local calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or '' 
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

local urlDecode = function(s)
                     return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                          "%%(%x%x)",
                                          function (str)
                                             return string.char (tonumber (str, 16))
                                          end )
                          )
                  end

local htmlEncode =function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end

local confToTable = function(str)
   local confTable, res
   local func, err = loadstring('setfenv(1, {}) '..str, "")
   if not func then
      return {_err = err or "Unknown error"}
   end
   res, confTable = pcall(func)
   return confTable or {}
end

_L = {
   start = function (ses, htmlEnv)
              local formParams = fstr(
                 '<INPUT type=hidden name="command" value="getHTML">',
                 '<INPUT type=hidden name="sesnum" value="',htmlEncode(htmlEnv.data.sesnum),'">',
                 '<INPUT type=hidden name="login" value="',htmlEncode(htmlEnv.data.login),'">',
                 '<INPUT type=hidden name="path" value="',htmlEncode(htmlEnv.data.path),'">',
                 '<INPUT type=hidden name="pass" value="',htmlEncode(htmlEnv.data.pass),'">'
              )
              local etc = ""
              if 0 == os.execute("[ -f /etc/newetc.tar.gz ]") then
                 etc =  fstr('<form method="POST" enctype="multipart/form-data" target="_self">',
                             formParams,
                             '<INPUT type=hidden name="subcmd"  value="rmetc">',
                             '<input type="submit" name="go"  value="Remove stored etc.tar.gz">',
                             '</form>',
                             '<form method="POST" enctype="multipart/form-data" target="_self">',
                             formParams,
                             '<INPUT type=hidden name="subcmd"  value="reboot">',
                             '<input type="submit" name="go"  value="Reboot with new etc">',
                             '</form>'
                          )
              end
              return true, fstr([[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                                <html>
                                <head>
                                <title>NSG Configurations</title>
                                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                                <script src="/jquery.js" type="text/javascript" ></script> 
                                <script src="/tinysort.js" type="text/javascript" ></script>
                                <xscript src="/boxover.js" type="text/javascript" ></script>
                                <xscript src="/webtty.js" type="text/javascript" ></script>
                                <link rel="stylesheet" type="text/css" href="/style.css">
                                <link rel="icon" type="image/x-icon" href="/nsg.ico">
                                <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico">
                                </head>]],
                       "<script type=\"text/javascript\">var SID=\"",
                       htmlEnv.data.sesnum,
                       "\";var PATH=",
                       ("%q"):format(htmlEnv.data.path),
                       ";var LOGIN=\"",
                       htmlEnv.data.login,
                       "\";var PASS=\"",
                       htmlEnv.data.pass,
                       "\";var AUTH=\"login=\"+LOGIN+ \"&pass=\" + PASS +\"&sesnum=\"+ SID +\"&path=\" + PATH + \"&\";var PAGENAME=\""..htmlEnv.data.pagename.."\";var LOCALE=\"",
                       locale,"\";var CONTENT=\"\";var TIMER=null; var REQUEST=null;</script>",
                       "<script src=\"/script.js\" type=\"text/javascript\" ></script>",
                       "<body >",
                       "<center><strong>NSG Configurations</strong></center><br/>",
                       "<p><center><h>Full device configuration(/etc), for full copying and restoring:</h>",
                       htmlEnv.banner and "<br><b>"..htmlEnv.banner..'</b></br>'  or "",
                       '<form method="POST" enctype="multipart/form-data" target="_blank">',
                       formParams,
                       '<INPUT type=hidden name="subcmd"  value="exportetc">',
                       '<input type="submit" name="go"  value="Get gziped /etc">',
                       '</form>',
                       '<form method="POST" enctype="multipart/form-data" target="_self">',
                       formParams,
                       '<INPUT type=hidden name="MAX_FILE_SIZE" value=3000000>',
                       '<INPUT type=hidden name="subcmd"  value="importetc">',
                       '<input type="file" name="file" size="70"><br />',
                       '<input type="submit" name="go"  value="Load new etc to device">',
                       '</form>',
                       etc,
                       "</center></p>",
                       '<p><center><h>Basic device configuration(/etc/nsgconfig), without passwords, configurations and external modules/applications:</h>',
                       '<form method="POST" enctype="multipart/form-data" target="_blank">',
                       formParams,
                       '<INPUT type=hidden name="subcmd"  value="exportconfig">',
                       '<input type="submit" name="go"  value="Get /etc/nsgconfig">',
                       '</form>',
                       '<form method="POST" enctype="multipart/form-data" target="_self">',
                       formParams,
                       '<INPUT type=hidden name="MAX_FILE_SIZE" value=500000>',
                       '<INPUT type=hidden name="subcmd"  value="importconfig">',
                       '<input type="file" name="file" size="70"><br />',
                       '<input type="submit" name="go"  value="Save to /etc/nsgconfig">',
                       '</form>',
                       '</center></p>',
                       '</body></html>'
                    )
            end,
   importetc = function (ses, htmlEnv)
               local buf="XX"
               local f=io.open("/etc/newetc.tar.gz","w")
               while type(buf)=='string' and #buf>0 do
                  buf = htmlEnv.data.file.file:read(1024*1024)
                  f:write(buf or "")
               end
               f:close()
               htmlEnv.banner = "New etc saved but not started! Reboot device to apply new etc!"
               return _L.start(ses, htmlEnv)
            end,
   exportetc = function (ses, htmlEnv)
               local f = io.popen("/bin/tar  -C /etc -c . | /bin/gzip", "r")
               local buf = f:read("*a")
               f:close()
               htmlEnv:headPrint("Accept-Ranges","bytes")
               htmlEnv:headPrint("Content-Length",#buf)
               htmlEnv:headPrint("Content-Type", "application/x-gzip")
               htmlEnv:headPrint("Content-Disposition",'form-data; name="AttachedFile"; filename="etc.tar.gz"')
               return true, buf or ""
            end, 
   exportconfig = function (ses, htmlEnv)
               local f = io.popen("/bin/cat /etc/nsgconfig", "r")
               local buf = f:read("*a")
               f:close()
               buf = nsg.serialize(confToTable(buf), 1)
               htmlEnv:headPrint("Accept-Ranges","bytes")
               htmlEnv:headPrint("Content-Length",#buf)
               htmlEnv:headPrint("Content-Type", "text/plain")
               htmlEnv:headPrint("Content-Disposition",'form-data; name="AttachedFile"; filename="nsgconfig"')

               return true, buf or ""
            end,

   importconfig = function (ses, htmlEnv)
                     local nsg = require"nsg"
                     local buf = htmlEnv.data.file.file:read("*a")
                     local res = confToTable(buf)

                     if res["_err"] then
                        htmlEnv.banner = "Error:"..htmlEncode(res["_err"])
                        return _L.start(ses, htmlEnv)
                     else
                        local f = io.open("/etc/nsgconfig","w")
                        if f then
                           f:write("return"..nsg.serialize(res))
                           f:close()
                           htmlEnv.banner = "Configuration saved:<br><div style=\"align=left;\"><pre>"..htmlEncode(nsg.serialize(res, 1)).."</pre></div>"
                        else
                           htmlEnv.banner = "Error: Can`t open/create file /etc/nsgconfig  for writing!"
                        end
                        return _L.start(ses, htmlEnv)
                     end
                  end,

   rmetc = function (ses, htmlEnv)
              os.execute("rm -f /etc/newetc.tar.gz")
              return _L.start(ses, htmlEnv)
           end,

   reboot = function (ses, htmlEnv)
              os.execute("reboot")
              return true, "rebooting....."
           end,
}


-- Entry point for call from web
function getHTML(ses, htmlEnv)
   if _L[htmlEnv.data.subcmd]  then
      local res, a,b,c,d = pcall((_L[htmlEnv.data.subcmd]),ses, htmlEnv)
     -- io.write(tostring(res))
     -- io.write(tostring(a))
     -- io.write(tostring(b))
     -- io.write(tostring(c))
     -- io.write(tostring(d))
      return a,b,c,d
   else
      --io.write( "Can`t find function `"..htmlEnv.data.subcmd.."` in module `configurations`.")
      return nil, "Can`t find function `"..htmlEnv.data.subcmd.."` in module `configurations`."
   end

end