module(..., package.seeall)
local s = require'scheme'
----------------------------------------

searchHelpScheme = s.stringType {
   _H = 'searchHelp',
   _P = 1000,
   _R = 'user',
   _A = {""},
   _V = function(val)
           return tostring(val)
        end,
   _X = function(path, sch, val, sesNum)
           if val then
              local si = sesNum and C.getSessionInfo(sesNum) or {}
              path = s.clonePath(path, -1) or {}
              sch =  C.getSchemeByPath(path)
              cnf = C.getConfByPath(path)
              return s.searchHelp(sch, cnf, path, val, si.locale)
           end
           return "nothing to search"
        end,
}