require"socket"
require"serialize"
local serialize=serialize.serialize
local socket = socket
local ui = ui
local string = string
local loadstring = loadstring
local pcall = pcall
local table = table
local setmetatable = setmetatable
local getfenv = getfenv
local ipairs = ipairs
local type = type
module(...)
host = "127.0.0.1"
port = 50006
tmo = 3
local function uitcpapi(name, ...)
  local sock, status = socket.tcp()
  sock:settimeout(tmo)
  local c, status = sock:connect(host, port)
  if not c then return nil, status end
  local par = {}
  for i, v in ipairs({...}) do
    par[i] = serialize(v)
  end
  local com = string.format("%s(%s)", name, table.concat(par,','))
  sock:send(com)
  sock:settimeout(tmo)
  local data, status, partial = sock:receive("*a")
  data = data or partial
  local f, err = loadstring("return "..data)
  if not f then return nil, err, data end
  local status, t = pcall(f)
  if not status then return nil, t, err end
  if type(t) ~= "table" then return nil, "Can't parse answer", data end
  if t.ERR then return nil, t.ERR, data end
  return t, data
end
__index = function(t, k) 
            return function(...) return uitcpapi(k, ...) end
end
local t = getfenv()
setmetatable(t, t)

